
-- Setup
local loader = require("AdvTiledLoader.Loader")
loader.path = "maps/"
local map = loader.load("tree.tmx")
local tileLayer = map.layers["terreno"]
require ("mobs")


function Boy.moveTile(x,y)

    -- Cambia la direzione di boxboy.
    if x > 0 then Boy.facing = "right"
    elseif x < 0 then Boy.facing = "left"
    elseif y > 0 then Boy.facing = "down"
    else Boy.facing = "up" end
    
    -- Prende il tile in cui si deve muovere.
    local tile = tileLayer(Boy.tileX + x, Boy.tileY + y)

    -- Se il tile non esiste o è un ostacolo,non muoveere.
    if tile == nil then return end
    if tile.properties.obstacle then return end
    
    -- Altrimenti sposta boxboy
    Boy.tileX = Boy.tileX + x
    Boy.tileY = Boy.tileY + y
    Boy.x = Boy.tileX * map.tileWidth
    Boy.y = (Boy.tileY + 1) * map.tileHeight - Boy.height
end

---------------------------------------------------------------------------------------------------
-- Fare ad inizio del livello in modo da assicurarsi che boxboy sia nel posto giusto
Boy.moveTile(0,0)
Boy.facing = "down"

---------------------------------------------------------------------------------------------------
-- Dichiarato come classe.
local TreeExample = {}

---------------------------------------------------------------------------------------------------
-- Funzione che verrà richiamata nel main
function TreeExample.keypressed(k)
    if k == 'w' then Boy.moveTile(0,-1) end
    if k == 'a' then Boy.moveTile(-1,0) end
    if k == 's' then Boy.moveTile(0,1) end
    if k == 'd' then Boy.moveTile(1,0) end
end

---------------------------------------------------------------------------------------------------
-- Prepara camera e boxboy per il prossimo livello
function TreeExample.nextLevel()
    global.tx = -5
    global.ty = -434
    Boy.tileX = 8
    Boy.tileY = 22
    Boy.moveTile(0,0)
    Boy.facing = "down"
    displayTime = 0
end

---------------------------------------------------------------------------------------------------
-- Aggiorna mappa.
function TreeExample.update(dt)
end

---------------------------------------------------------------------------------------------------
-- Called from love.draw()
function TreeExample.draw()

    -- Set sprite batches if they are different than the settings.
    map.useSpriteBatch = global.useBatch

    -- Scale and translate the game screen for map drawing
    local ftx, fty = math.floor(global.tx), math.floor(global.ty)
    love.graphics.push()
    love.graphics.scale(global.scale)
    love.graphics.translate(ftx, fty)
    
    -- Limit the draw range 
    if global.limitDrawing then 
        map:autoDrawRange(ftx, fty, global.scale, -100) 
    else 
        map:autoDrawRange(ftx, fty, global.scale, 50) 
    end
    
    -- Queue our Boy to be drawn after the tile he's on and then draw the map.
    local maxDraw = global.benchmark and 20 or 1
    for i=1,maxDraw do 
        map:draw() 
        love.graphics.draw(Boy.image, Boy.quads[Boy.facing], Boy.x, Boy.y) 
    end
    love.graphics.rectangle("line", map:getDrawRange())
    
    -- Reset the scale and translation.
    love.graphics.pop()
    
end

---------------------------------------------------------------------------------------------------
return TreeExample
